## apr 1.6.5

=== debian/changelog ===
apr (1.6.5-1ubuntu1.1) focal-security; urgency=medium

  * SECURITY UPDATE: local information disclosure via shared memory segments
    - debian/patches/CVE-2023-49582.patch: adjust permissions on shared 
      memory segments to prevent unauthorized access in shmem/unix/shm.c
    - CVE-2023-49582 

 -- Vyom Yadav <vyom.yadav@canonical.com>  Tue, 17 Sep 2024 18:46:02 +0530

apr (1.6.5-1ubuntu1) focal; urgency=medium

  * FTBFS fixes:
    - Build-Depends explicitly on python2, not python.
    - d/p/python2.patch: use python2 in command invocations, not the generic
      python name.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 18 Feb 2020 14:53:35 +0000

apr (1.6.5-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version (no changes).

 -- Stefan Fritsch <sf@debian.org>  Mon, 19 Nov 2018 13:28:03 +0100

apr (1.6.3-3) unstable; urgency=medium

  * Backport fix for undefined behavior in teststr from upstream 1.7.
    Fixes FTBFS with gcc 8. Closes: #897705
  * Migrate from alioth to salsa

 -- Stefan Fritsch <sf@debian.org>  Tue, 17 Jul 2018 21:17:00 +0200
