=== debian/control ===
Source: apr
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Uploaders: Stefan Fritsch <sf@debian.org>
Build-Depends: debhelper (>= 11), autoconf, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python2:any, libsctp-dev [linux-any]
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/apache-team/apr
Vcs-Git: https://salsa.debian.org/apache-team/apr.git
Homepage: http://apr.apache.org/

Package: libapr1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Conflicts: libapr1.0
Description: Apache Portable Runtime Library
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 

Package: libapr1-dev
Architecture: any
Section: libdevel
Depends: libapr1 (= ${binary:Version}), uuid-dev, ${misc:Depends}, libsctp-dev [linux-any]
Suggests: python
Conflicts: libapr1.0-dev, libapr0-dev
Description: Apache Portable Runtime Library - Development Headers
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 This package contains development headers for APR.

Package: libapr1-dbg
Architecture: any
Section: debug
Multi-Arch: same
Depends: libapr1 (= ${binary:Version}), ${misc:Depends}
Description: Apache Portable Runtime Library - Debugging Symbols
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 This package contains the debugging symbols for APR.
