## apr 1.7.0

=== debian/changelog ===
apr (1.7.0-8build1) jammy; urgency=medium

  * No-change rebuild for ppc64el baseline bump.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 23 Mar 2022 10:40:37 +0100

apr (1.7.0-8) unstable; urgency=medium

  * Team upload

  [ Salvatore Bonaccorso ]
  * build/apr_common.m4: avoid explicit inclusion of "confdefs.h"
    (Closes: #978767)

 -- Yadd <yadd@debian.org>  Tue, 24 Aug 2021 10:54:34 +0200

apr (1.7.0-7) unstable; urgency=medium

  * Team upload

  [ Helmut Grohne ]
  * Annotate test dependencies netbase and net-tools <!nocheck>.
    Closes: #981738

  [ Salvatore Bonaccorso ]
  * Out-of-bounds array dereference in apr_time_exp*() functions
    (CVE-2021-35940) (Closes: #992789)

 -- Yadd <yadd@debian.org>  Tue, 24 Aug 2021 08:59:10 +0200

apr (1.7.0-6) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Fix atomics for m68k, sh3 and sh4. Closes: #978018

 -- Stefan Fritsch <sf@debian.org>  Sun, 27 Dec 2020 17:28:47 +0100

apr (1.7.0-4) unstable; urgency=low

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Transition to automatic debug package (from: libapr1-dbg).
  * Use secure URI in Homepage field.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.

  [ Stefan Fritsch ]
  * Fix apr libtool on unmerged /usr. Thanks to Vagrant Cascadian for
    the patch. Closes: #916829
  * Bump Standards-Version (no changes).

 -- Stefan Fritsch <sf@debian.org>  Sat, 21 Nov 2020 21:06:09 +0100

apr (1.7.0-3) unstable; urgency=medium

  * Bump Standards-Version (no changes).
  * Fixes for 64bit atomics work-around:
    - call the required initialization
    - don't use on mips64el
    - use on powerpc

 -- Stefan Fritsch <sf@debian.org>  Sun, 30 Aug 2020 21:15:21 +0200

apr (1.7.0-2) unstable; urgency=medium

  * Use generic 64bit atomics on mipsel as gcc lacks the 64bit built-ins.
    Fixes FTBFS on mipsel.

 -- Stefan Fritsch <sf@debian.org>  Sat, 29 Aug 2020 18:13:56 +0200

apr (1.7.0-1) unstable; urgency=medium

  * New upstream release.
    The minimal required linux kernel version is now 3.17.
  * Switch build-depends to python3. Closes: #936128, #969065
    Make apr1-dev depend on python3, so that apr-util does not have to.
    See #936129

 -- Stefan Fritsch <sf@debian.org>  Sat, 29 Aug 2020 11:42:28 +0200
