=== debian/control ===
--- 
+++ 
@@ -3,22 +3,26 @@
 Priority: optional
 Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
 Uploaders: Stefan Fritsch <sf@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  autoconf,
  mawk,
  uuid-dev,
  doxygen,
  netbase <!nocheck>,
  net-tools <!nocheck>,
- libtool (>= 2),
+ libtool,
  python3:any,
  libsctp-dev [linux-any]
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/apache-team/apr
 Vcs-Git: https://salsa.debian.org/apache-team/apr.git
 Homepage: https://apr.apache.org/
+Rules-Requires-Root: no
 
-Package: libapr1
+Package: libapr1t64
+Provides: ${t64:Provides}
+Replaces: libapr1
+Breaks: libapr1 (<< ${source:Version})
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
