=== debian/changelog ===
apr (1.7.5-1) unstable; urgency=medium

  * New usptream version
    - CVE-2023-49582: Unexpected lax shared memory permissions
      Closes: #1080375

 -- Stefan Fritsch <sf@debian.org>  Sat, 07 Sep 2024 11:01:36 +0200

apr (1.7.2-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix symbols files which are in a non-standard location.

 -- Steve Langasek <vorlon@debian.org>  Fri, 08 Mar 2024 19:11:28 +0000

apr (1.7.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061894

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 01:17:18 +0000
