## apr 1.7.6

=== debian/changelog ===
apr (1.7.6-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Explicitly depend on libcrypt-dev. (Closes: #1102909)
  * Fix FTCBFS: Supply result for cross-process mutex. (Closes: #1050770)

  [ Stefan Fritsch ]
  * New upstream version
  * Enable sctp explicitly in configure. Closes: #1104500

 -- Stefan Fritsch <sf@debian.org>  Wed, 05 Nov 2025 21:59:04 +0100
