=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
http://www.apache.org/dist/apr/apr-(1\..*)\.tar\.gz
